// MyExt.cpp

#include "dbgexts.h"

HRESULT CALLBACK 
helloworld(PDEBUG_CLIENT pDebugClient, PCSTR args)
{
	UNREFERENCED_PARAMETER(args);

	PDEBUG_CONTROL pDebugControl;
	if (SUCCEEDED(pDebugClient->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl)))
	{
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "Hello World!\n");
		pDebugControl->Release();
	}
	return S_OK;
}

/*
0:000> x test01!g_ptr
012f3370 Test01!g_ptr = 0x012f20e4

0:000> !gptr
012f3370 test01!g_ptr = 0x012f20e4
<string>
*/
HRESULT CALLBACK 
gptr(PDEBUG_CLIENT pDebugClient, PCSTR args)
{
	UNREFERENCED_PARAMETER(args);

	IDebugSymbols* pDebugSymbols;
	if (SUCCEEDED(pDebugClient->QueryInterface(__uuidof(IDebugSymbols), (void **)&pDebugSymbols)))
	{	// Resolve the symbol
		ULONG64 ulAddress = 0;
		if (SUCCEEDED(pDebugSymbols->GetOffsetByName("test01!g_ptr", &ulAddress)))
		{
			IDebugDataSpaces* pDebugDataSpaces;
			if (SUCCEEDED(pDebugClient->QueryInterface(__uuidof(IDebugDataSpaces), (void **)&pDebugDataSpaces)))
			{	// Read the value of the pointer from the target address space
				ULONG64 ulPtr = 0;
				if (SUCCEEDED(pDebugDataSpaces->ReadPointersVirtual(1, ulAddress, &ulPtr)))
				{
					PDEBUG_CONTROL pDebugControl;
					if (SUCCEEDED(pDebugClient->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl)))
					{	// Output the values
						pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "%p test01!g_ptr = 0x%p\n", ulAddress, ulPtr);
						pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "%ma\n", ulPtr);
						pDebugControl->Release();
					}
				}
				pDebugDataSpaces->Release();
			}
			pDebugSymbols->Release();
		}
	}
	return S_OK;
}
